/*
**	audio.c
*/
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>

#define BS (2048*2)
#define OBS (512*2)
short obf[OBS];
short ibf[BS];

#define AMP 32000

int channels;
int audio_fd = -1;
int mixer_fd = -1;
int play_precision;
int play_stereo;
int play_sample_rate;
int be= 0;
int freq=44100;
int volume=100;
int noc=2;

FILE *os=NULL;
FILE *is=NULL;

usage0(prog)
char *prog;
	{
	fprintf(stderr,"Usage:%s [-][-b][-fN][-vN] [file1 file2] \n",prog);
	fprintf(stderr,"-   from stdin to stdout\n");
	fprintf(stderr,"-m  mono\n");
	fprintf(stderr,"-b  Big Endian\n");
	fprintf(stderr,"-fN N: sampling frequency [Hz]\n");
	fprintf(stderr,"-vN N: [1,100] volume\n");
	exit(1);
	}

main0(argc, argv)
int     argc;
char    *argv[];
	{
	char *prog= argv[0];
	argc--; argv++;
        while (argc) {
		if (strncmp(*argv,"-v",2)==0) volume= atoi(*argv+2);
		else if (strncmp(*argv, "-f",2)==0) freq= atoi(*argv+2);
		else if (strcmp(*argv, "-b")==0) be= 1;
		else if (strcmp(*argv, "-m")==0) noc= 1;
        	else if (strcmp(*argv, "-") ==0) { os= stdout; is= stdin; }
        	else if (**argv == '-') {
                        fprintf(stderr, "unknown option: %s\n", *argv);
                        usage(prog);
                        }
                else break;
                argc--; argv++;
                }

	if(argc--==1){
		/*
       		if ((os = fopen(*argv++,"r")) == NULL) {
                	fprintf(stderr, "can't read open \n"); exit(1); }
		*/
       		if ((is = fopen(*argv++,"w")) == NULL) {
                	fprintf(stderr, "can't write open \n"); exit(1); }

	} else { if(os!=stdout)usage(prog); }

	soundio();
	}


soundin()
{ int l; while(l= read(audio_fd,ibf,sizeof(ibf))) fwrite (ibf,1,l,is); }

soundout()
	{
	char *buf;
	int l, len, n;
	while(l= fread(obf,1,sizeof(obf),os)){
		if(be)big_endian();
		buf = (char *)obf; len = l;
		while(len) {
			if ((n= write (audio_fd, buf, len)) < 0) {
				if (errno != EINTR)
				{perror("write to /dev/dsp failed");exit(1);}
				n= 0;
				}
			len-= n; buf+= n;
			}
		}
	}

soundio(c)
	{
	int l=0;
	int r=0;
	int of= OBS-16;
	int a= AMP;

	if(c){	obf[of+1]= a;/* obf[of+3]=  a; obf[of+5]= a; obf[of+7]=  a;*/
		obf[of  ]= 0;/* obf[of+2]=  0; obf[of+4]= 0; obf[of+6]=  0;*/}
	 else{	obf[of+1]= 0;/* obf[of+3]=  0; obf[of+5]= 0; obf[of+7]=  0;*/ 
		obf[of  ]= a;/* obf[of+2]=  a; obf[of+4]= a; obf[of+6]=  a;*/ }
	
	open_audio_device (noc,freq,volume);

	while(l<sizeof(obf))
		l+= write (audio_fd, obf+l, sizeof(obf)-l);

	close(audio_fd);
	close(mixer_fd);
	open_audio_device (noc,freq,volume);


	while(r<sizeof(ibf))
		r+= read(audio_fd,ibf+r,sizeof(ibf)-r);

	fwrite (ibf,1,sizeof(ibf),is);

	close(audio_fd);
	close(mixer_fd);
	}

big_endian()
	{
	int i;
	unsigned int d;
	for(i=0;i<BS;i++){
		d= (unsigned short)obf[i];
		obf[i]= d<<8 | d>>8;
		}
	}

open_audio_device (noc,freq,volume)
int noc;	/* nomber_of_channels      */
int freq;	/* sampling frequency [kHz]*/
int volume;	/* volume 0-100 */
{
  int i, fd, flags, ret, devices, vol_chan;

  if ((fd = open ("/dev/dsp", O_RDWR | O_NDELAY, 0)) < 0){
	/*
  if ((fd = open ("/dev/dsp", O_WRONLY | O_NDELAY, 0)) < 0){
	*/
      fprintf(stderr,"audio device /dev/dsp is busy or can't be opened\n");
      exit(1);
    }
  audio_fd= fd;
  /* turn NDELAY mode off: */
  if ((flags = fcntl (fd, F_GETFL, 0)) < 0) {
    fprintf(stderr,"fcntl F_GETFL on /dev/audio failed\n");
    exit(1);
  }
  flags &= ~O_NDELAY;
  if (fcntl (fd, F_SETFL, flags) < 0) {
    fprintf(stderr,"fcntl F_SETFL on /dev/audio failed\n");
    exit(1);
  }
  channels = noc;
  /* configure the device: */
  play_precision= 16;
  play_stereo = channels-1;
  play_sample_rate = freq;
  if(
      ioctl(fd, SNDCTL_DSP_SAMPLESIZE, &play_precision) == -1 ||
      ioctl(fd, SNDCTL_DSP_STEREO, &play_stereo) == -1 ||
      ioctl(fd, SNDCTL_DSP_SPEED, &play_sample_rate) == -1
    )
  { fprintf(stderr,"configuration of /dev/dsp failed\n"); exit (1); }

  if ((mixer_fd= fd = open ("/dev/mixer", O_WRONLY | O_NDELAY, 0)) < 0){
      fprintf(stderr,"audio device /dev/mixer is busy or can't be opened\n");
      exit(1);
    }
  ret = ioctl(fd, SOUND_MIXER_READ_DEVMASK, &devices);
  if (ret == -1) devices = 0;
  if (devices & (1 << SOUND_MIXER_PCM))
              vol_chan = SOUND_MIXER_PCM;
  else        vol_chan = SOUND_MIXER_VOLUME;
  volume |= volume << 8;
  if( ioctl(fd, MIXER_WRITE(vol_chan), &volume) == -1)
  { fprintf(stderr,"configuration of /dev/mixer failed\n"); exit (1); }
}

