/*
**
**	wave.c
**
*/
#include "wave.h"

#define BS (2048*2) /* buffer size [short] */
#define WX 800  /* window horizontal size */
#define WY 500	/* window vertical   size */
extern	short	ibf[BS];
short	bf[BS];		/* wave buffer */
XPoint	pts[WX*2];	/* wave display XPoints */
char	name[256];	/* file name   */
int wx= WX,wy=WY;
int st=  0;	/* start point of the file buffer */
int std= 0;	/* speed: points/image */
int sep= 0;	/* separate display for 2 channels */
int sp=  0;	/* a flag indicates gettting start position */
int ep=  0;	/* a flag indicates gettting end   position */ 
int spv1= 0;	/* start position value */
int spv2= 0;	/* start position value */
int epv1= WX-1;	/* end position value */
int epv2= WX-1;	/* end position value */
int scal=4;	/* scal: 16 bit dsp val >> scal --> y */
int sd=  0;	/* display horizontal expansion 2^sd  */

usage(cmd)
char *cmd; { fprintf(stderr,"Usage: %s [file]\n",cmd); exit(1); }

main(argc,argv)
char **argv;
	{
	//unlink(*argv);
	if(argc>2)usage(*argv);
	strcpy(name,*argv);
	if(argc==2){
		file_read(argv[1]);
		strcat(name,": ");
		strcat(name,argv[1]);
	}
	iwt(name, wx, wy);

	XDrawLine(dpy,w1,gc,0,wy/2,wx-1,wy/2);
	mkgrid();
	draw_wave(1);
	while(1)
	disp_wave();
}

disp_wave(){
if(std){
	st+= std;
	if (st>BS-wx*2){ st= BS-wx*2; std= 0; speed_disp(std); }
	if (st<    0){ st=0; std= 0; speed_disp(std); }
	draw_wave(0);
	}
if (XCheckMaskEvent(dpy, ButtonReleaseMask | PointerMotionMask |
	ButtonPressMask   | StructureNotifyMask , &pe)) events();
usleep(10000);
}

draw_wave(start){ int i;
if(start==0) XDrawPoints(dpy,w1,gc,pts,wx*2,CoordModeOrigin); /* delete wave */
for(i=0;i<wx*2;i++){
	int k= ((i>>sd)&-2)|(i&1);
	pts[i].y= -(bf[st+k]>>scal);
	if(sep) pts[i].y+= (1+(i&1))*wy/3;
	 else	pts[i].y+= wy/2;
	pts[i].x= i/2;
	}
XDrawPoints(dpy,w1,gc,pts,wx*2,CoordModeOrigin);/* write wave */
pos_disp(st);
scale_disp(scal);
}

file_read(name) char *name; {
	FILE *fp;
	int ret;
	if((fp= fopen(name,"r"))==NULL){
		fprintf(stderr,"file %s cannot be opend\n",name);
		exit(1);
	}
	ret= fread(bf,1,sizeof(bf),fp);
	fclose(fp);
	average(bf,ret/2);
	average(bf+1,ret/2);
}

file_write(name) 
char 	*name;
{
	FILE *fp;
	char c[256];
	char c2[256];
	int	i;
	XDrawString(dpy,w1,gc,10,30,"put filename (to mother window):",32);
	XFlush(dpy);
	gets(c);
	XDrawString(dpy,w1,gc,250,30,c,strlen(c));
	XFlush(dpy);

	strcpy(c2,c);
	strcat(c,"1");
	if((fp= fopen(c,"w"))==NULL){ fprintf(stderr,"file %s can not open\n",c); exit(1); }
	if(spv1>epv1){ i= spv1; spv1= epv1; epv1= i; }
	for(i=spv1;i<=epv1;i+=2) { int d= *(bf+i); putc(d,fp); putc(d>>8,fp); }
	fclose(fp);

	strcat(c2,"2");
	if((fp= fopen(c2,"w"))==NULL){ fprintf(stderr,"file %s can not open\n",c); exit(1); }
	if(spv2>epv2){ i= spv2; spv2= epv2; epv2= i; }
	for(i=spv2+1;i<=epv2;i+=2) { int d= *(bf+i); putc(d,fp); putc(d>>8,fp); }
	fclose(fp);

	usleep(200000);
	XDrawString(dpy,w1,gc,10,30,"put filename (to mother window):",32);
	XDrawString(dpy,w1,gc,250,30,c,strlen(c));
	XFlush(dpy);
}

average(bf,size) short *bf; {
	int i, sum= 0;
	for(i=0;i<size;i+=2) sum+= bf[i];
	sum/= size/2;
	for(i=0;i<size;i+=2) bf[i]-= sum;
}

events() {
             if(pe.type == ButtonRelease) button_on();
        else if(pe.type == ButtonPress) ;
        else if(pe.type == MotionNotify);
        else if(pe.type == ConfigureNotify);
}


#define NB 13
static char aria[16][32]={
"Slow",	"Trim", "Fast", "Magnif", "startP",
"endP",	"Open", "Save", "Seprt", "Implse", "Clear", "Expand", "Exit"
};

mkgrid() {
	int i, sp= wy-20;
	XDrawLine(dpy,w1,gc,0,sp, wx-1,sp);
	XDrawLine(dpy,w1,gc,0,wy-1,wx-1,wy-1);
	for(i=0;i<NB;i++){
		XDrawLine(dpy,w1,gc,wx*i/NB,sp, wx*i/NB,wy-1);
		XDrawString(dpy,w1,gc,wx*i/NB+6,sp+14,aria[i],strlen(aria[i]));
	}
	XDrawLine(dpy,w1,gc,wx-1,sp, wx-1,wy-1);
}

speed_disp(std) {
	static char s[256];
	XDrawString(dpy,w1,gc,wx-80,10,s,strlen(s));
	sprintf(s,"speed= %4d",std/2);
	XDrawString(dpy,w1,gc,wx-80,10,s,strlen(s));
}

scale_disp(scal) {
	static char s[256];
	XDrawString(dpy,w1,gc,wx-70,30,s,strlen(s));
	sprintf(s,"sc=%f",1./(1<<scal));
	XDrawString(dpy,w1,gc,wx-70,30,s,strlen(s));
}

pos_disp(pos) {
	static char s[256];
	XDrawString(dpy,w1,gc,wx-250,50,s,strlen(s));
	sprintf(s,"t=%5d, c1(t)=%6d, c2(t)=%6d",
		    pos/2,   bf[pos],   bf[pos+1]);
	XDrawString(dpy,w1,gc,wx-250,50,s,strlen(s));
}

button_on() {
	int x,y,d=1,j;
	x= pe.xbutton.x;
	y= pe.xbutton.y;
	if(pe.xbutton.button==Button3)d= -1;

	if(y<wy-20){
		if(sp){ sp= 0;
			if(y<wy/2){spv1= (2*x)>>sd; XDrawLine(dpy,w1,gc,x,0,x,wy/2-1);}
			 else     {spv2= (2*x)>>sd; XDrawLine(dpy,w1,gc,x,wy/2,x,wy-1);}
		}
		if(ep){ ep= 0;
			if(y<wy/2){epv1= (2*x)>>sd; XDrawLine(dpy,w1,gc,x,0,x,wy/2-1);}
			 else     {epv2= (2*x)>>sd; XDrawLine(dpy,w1,gc,x,wy/2,x,wy-1);}
		}
		pos_disp(st+((2*x)>>sd));
		return;
	}
	switch(j=x*NB/wx){
		case 0: std+= d*2; goto com;
		case 1: st+=  d*2; goto com2;
		case 2: std+= d*20; com: speed_disp(std); break;
		case 3: scal+= d;  com2: draw_wave(0); break;
		case 4: sp= 1; break;
		case 5: ep= 1; break;
		case 6: file_read(name); break;
		case 7: file_write(name); break;
		case 8: sep= 1-sep;
			XDrawLine(dpy,w1,gc,0,wy/2,wx-1,wy/2);
			XDrawLine(dpy,w1,gc,0,wy/3,wx-1,wy/3);
			XDrawLine(dpy,w1,gc,0,wy*2/3,wx-1,wy*2/3);
			goto com2;
		case 9: add10(); break;
		case 10: clear_bf(); goto com2;
		case 11: sd+= d; if(sd<0) sd= 0; goto com2;
		case 12: exit(0);
	}
}

clear_bf() { int i; for(i= 0; i<BS; i++) bf[i]= 0; }

add10() { int i,j;	/* c: 0 left 1: right */
	for(j=0;j<256;j++){
		soundio(0); for(i= 0; i<BS; i+=2) bf[i]+= ibf[i];
		average(bf,BS);
		draw_wave(0);
		soundio(1); for(i= 1; i<BS; i+=2) bf[i]+= ibf[i];
		average(bf+1,BS);
		draw_wave(0);
	}
}
/*
average(bf,size) short *bf; {
	int i, sum= 0;
	for(i=0;i<size;i+=2) sum+= bf[i];
	sum/= size/2;
	for(i=0;i<size;i+=2) bf[i]-= sum;
}
*/
